#include <OneWire.h>
#include <LiquidCrystal.h>
#include <DallasTemperature.h>
#include <BMP085.h>
#include <Wire.h>
#define ONE_WIRE_BUS 8                           // Пин датчиков температуры
#define Tvoda 84.5                               // Уставка когда включать воду
#define Tvoda2 85.5                              // Перестает пищать
#define Tstop 98.2                               // Заканчивать дистиляцию по температуре
#define Kstop 10                                 // Заканчивать дистиляцию по крепости
//#define Tvoda 27.0                             // тест работы разкоментировать для проверки
//#define Tvoda2 29.0                            // при низкой
//#define Tstop 31.0                             // температуре
LiquidCrystal lcd(4, 5, 10, 11, 12, 13);         // Пины дисплея
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
DeviceAddress Thermometer1 = {                   // Термометр температуры куба
  0x28, 0x4E, 0xF5, 0x55, 0x06, 0x00, 0x00, 0x84 // адрес термоментра в кубе, вставляете свой иначе температуру показывать не будет
                             }; 
DeviceAddress Thermometer2 = {                   // Термометр температуры дистиллятора
  0x28, 0xCF, 0xC6, 0xD2, 0x05, 0x00, 0x00, 0x28 // адрес термоментра в дистилляторе, вставляете свой иначе температуру показывать не будет
                             }; 
 BMP085 dps = BMP085();
 long Temperature = 0, Pressure = 0, Altitude = 0;
 int E=1;                                        // Если вы используете датчик переполнения емкости оставьте 1, если не используете поставьте 0, иначе будет постоянно орать.
 int W=0;                                        // Если вы используете датчик протечки воды оставьте 1, если не используете поставьте 0, иначе будет постоянно орать.
 int A=0;                                        // Если установить 0 - то заканчивать дистилляцию по температуре Tstop, если установить 1 - то оканчивать дистилляцию по достижениее указанной крепости Kstop 
 int F=0;                                        // Текущий режим диапозона температуры
 int B=1;                                        // Состояние звука, 1-вкл, 0-выкл НЕ МЕНЯТЬ ИНАЧЕ ЗВУК БУДЕТ РАБОТАТЬ НЕККОРЕКТНО
 int P1=0;
 int P2=0;
 float Pr=0;                                     // Текущее атмосферное давление
 float dT=0;                                     // Поправка температуры при изменении давления
 float dP=0;                                     // Разница между текущим давлением и 760 мм рт ст
 float Tp=0;                                     // Температура в помещении с датчика давления
 char V[]="V1.3";                                // Версия скетча
 float dTK=0;                                    // Коррекция датчика температуры куба, если датчик в кипящей воду при нормальном давлении показывает меньше 100*С, ставите разницу с плюсом, (например 0.1), если больше 100*, ставите разницу с минусом (например -0.1)
 float dTD=0;                                    // Кореркция датчика температуры дистиллятора
 float dTD78_81=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 78-81*C, например делаем контрольное измерение крепости при температуре 79,5*С, если датчик показывает правильно оставляем 0, значение может быть положительным или отрицательным, разделитель между целыми и десятыми точка (.)
 float dTD81_84=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 81-84*C, замер крепости при 82,5*C
 float dTD84_87=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 84-87*C, замер крепости при 85,5*C
 float dTD87_90=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 87-90*C, замер крепости при 88,5*C
 float dTD90_91=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 90-91*C, замер крепости при 90,5*C
 float dTD91_92=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 91-92*C, замер крепости при 91,5*C
 float dTD92_93=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 92-93*C, замер крепости при 92,5*C
 float dTD93_94=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 93-94*C, замер крепости при 93,5*C
 float dTD94_95=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 94-95*C, замер крепости при 94,5*C
 float dTD95_96=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 95-96*C, замер крепости при 95,5*C 
 float dTD96_97=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 96-97*C, замер крепости при 96,5*C
 float dTD97_98=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 97-98*C, замер крепости при 97,5*C
 float dTD98_99=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 98-99*C, замер крепости при 98,5*C
 float dTD99_100=0;                              // Коррекция датччка температуры дистиллятора в диапозоне 99-100*C, замер крепости при 99,5*C
 // Массив температур для расчета крепости в дистилляторе
 float T[123] = {78.18, 78.21, 78.24, 78.28, 78.31, 78.34, 78.37, 78.40, 78.44, 78.47, 78.50, 78.53, 78.57, 78.60, 78.66, 78.71, 78.76, 78.80, 78.86, 78.89, 78.95, 79.00, 79.05, 79.10, 79.15, 79.20, 79.27, 79.30, 79.35, 79.40, 79.44, 79.50, 79.55, 79.60, 79.65, 79.71, 79.75, 79.77, 79.84, 79.89, 79.96, 80.03, 80.10, 80.18, 80.25, 80.29, 80.39, 80.48, 80.57, 80.66, 80.75, 80.87, 80.95, 81.05, 81.15, 81.25, 81.34, 81.45, 81.55, 81.64, 81.75, 81.85, 81.94, 82.05, 82.16, 82.28, 82.43, 82.55, 82.78, 82.90, 83.00, 83.12, 83.25, 83.37, 83.50, 83.65, 83.78, 83.92, 84.16, 84.20, 84.36, 84.55, 84.72, 84.90, 85.10, 85.28, 85.50, 85.73, 85.96, 86.20, 86.46, 86.77, 87.10, 87.45, 87.76, 88.13, 88.50, 88.92, 89.45, 89.90, 90.47, 91.05, 91.85, 92.90, 93.42, 93.94, 94.46, 94.98, 95.50, 96.02, 96.54, 97.06, 97.58, 98.10, 98.29, 98.48, 98.67, 98.86, 99.05, 99.24, 99.43, 99.62, 99.81};
 // Массив крепостей для расчета крепости в дистилляторе
 float K[123] = {97.07, 96.77, 96.53, 96.26, 95.99, 95.70, 95.40, 95.12, 94.87, 94.61, 94.35, 94.12, 93.88, 93.65, 93.42, 93.20, 92.97, 92.73, 92.49, 92.25, 92.03, 91.80, 91.56, 91.34, 91.11, 90.87, 90.62, 90.38, 90.12, 89.89, 89.61, 89.36, 89.11, 88.87, 88.63, 88.38, 88.14, 87.92, 87.69, 87.47, 87.26, 87.06, 86.85, 86.67, 86.45, 86.27, 86.06, 85.87, 85.67, 85.49, 85.30, 85.11, 84.88, 84.67, 84.48, 84.25, 84.01, 83.80, 83.56, 83.32, 83.06, 82.79, 82.51, 82.23, 81.97, 81.69, 81.44 ,81.15 ,80.85 ,80.52, 80.35 ,80.19, 79.99, 79.82, 79.61, 79.44, 79.23, 78.99, 78.61, 78.46, 78.17, 77.88, 77.56, 77.15, 76.70, 76.21, 75.67, 75.06, 74.44, 73.79, 73.06, 72.27, 71.40, 70.49, 69.52, 68.48, 67.35, 66.19, 64.69, 63.00, 61.07, 59.03, 56.39, 52.95, 51.32, 49.50, 47.56, 45.35, 42.95, 40.38, 37.66, 34.75, 31.45, 27.96, 26.10, 23.76, 21.22, 18.48, 15.56, 12.57, 9.50, 6.36, 3.17};
 // спецсимвол градус
 
 byte gradus[8] = 
 {
  B01100,
  B10010,
  B10010,
  B01100,
  B00000,
  B00000,
  B00000,
  B00000,
 };
 // спецсимвол динамик
 byte sound[8] = 
 {
  B00001,
  B00011,
  B01111,
  B01111,
  B01111,
  B00011,
  B00001,
  B00000,
 };
 // спецсимвол звук включен
 byte soundon[8] = 
 {
  B00100,
  B10010,
  B01001,
  B00101,
  B01001,
  B10010,
  B00100,
  B00000,
 };
 // спецсимвол звук выключен
 byte soundoff[8] = 
 {
  B00000,
  B10001,
  B01010,
  B00100,
  B01010,
  B10001,
  B00000,
  B00000,
 };
 // спецсимвол Щ
 byte sch[8] = 
 {
  B00000,
  B00000,
  B10101,
  B10101,
  B10101,
  B10101,
  B11111,
  B00001,
 };
 // спецсимвол Л
 byte L[8] =
 {
  B00011,
  B00101,
  B01001,
  B01001,
  B01001,
  B01001,
  B11001,
  B00000,
 };
 // спецсимвол Я
 byte Ya[8] =
 {
  B01111,
  B01001,
  B01001,
  B01111,
  B00011,
  B00101,
  B01001,
  B00000,
 };
 // спецсимвол Ц
 byte C[8] =
 {
  B10010,
  B10010,
  B10010,
  B10010,
  B10010,
  B10010,
  B11111,
  B00001,
 };
 void setup() 
 {
   Serial.begin(9600);
   pinMode(9, OUTPUT);                        // 9 пин отвечает за яркость информации 
   analogWrite(9, 100);                       // на дисплее, можно установить свою вместо 100
   sensors.begin();
   // Устанавливаем точность измерения термометров в 0,0625*С, отображение на дисплее все равно ведется с округлением до десятых, а в расчетах эта точность
   sensors.setResolution(Thermometer1, 12);
   sensors.setResolution(Thermometer2, 12);
   Wire.begin();
   dps.init(MODE_ULTRA_HIGHRES, 0, true); 
   dps.getPressure(&Pressure);                // Читаем давление с датчика давления
   dps.getTemperature(&Temperature);          // Читаем температуру с датчика давления
   Pr=Pressure/133.3;                         // Переводим давление из паскалей в мм рт ст
   dP=Pr-760;                                 // Расчитываем разницу давлений между нормой 760 мм и текущим
   dT=0.035*dP;                               // Расчитываем поправку к температуре исходя из давления
   Tp=Temperature*0.1;                        // Температура в помещении
   lcd.createChar(1, gradus);
   lcd.createChar(4, C);
   lcd.createChar(5, sch);
   lcd.createChar(6, L);
   lcd.createChar(7, Ya);
   // Заставка с названием программы и номером версии 3 сек
   lcd.begin(16, 2);
   lcd.print("noMo\5Huk npu");
   lcd.setCursor(0, 1);
   lcd.print("DucTu\6\6\7\4uu");
   lcd.setCursor(12, 1);
   lcd.print(V);
   delay(3000);
   // Экран при загрузке с информацией о давлении и поправке температуры 8 сек
   lcd.clear();
   lcd.print("P:");
   lcd.print(Pr,0);
   lcd.print("mm dP:");
   lcd.print(dP,0);
   lcd.print("mm");
   lcd.setCursor(0, 1);
   lcd.print("T:");
   lcd.print(Tp,1);
   lcd.print("\1 dT:");
   lcd.print(dT,2);
   lcd.print("\1");
   delay(8000);
 }
 void loop() 
 {
   sensors.requestTemperatures();
   dps.getPressure(&Pressure);                    // Читаем давление с датчика давления
   lcd.createChar(1, gradus);
   lcd.createChar(2, sound);
   lcd.createChar(3, soundon);
   lcd.createChar(4, soundoff);
  float TempK1 = sensors.getTempC(Thermometer1);  // Читаем температуру датчика куба
  float TempD1 = sensors.getTempC(Thermometer2);  // Читаем температуру датчика дистиллятора
  float T1 = 0;
  float K1 = 0;                                   // Крепость кубового остатка
  float K2 = 0;                                   // Крепость пара в дистилляторе
  float TempK2 = TempK1 + dTK;                    // Вносим поправки температуры в датчик куба
  float TempD2 = TempD1 + dTD;                    // Вносим поправки температуры в датчик дистиллятора
  float TempD3 = TempD2;
  float TempD4 = TempD3;
  // Вносим поправку температуры в разных температурных диапозонах для более точного определения крепости
   if ((TempD2>=78) and (TempD2<81))
   {
    TempD3 = TempD2+dTD78_81;
   }
   if (TempD2>=81 && TempD2<84)
   {
    TempD3 = TempD2+dTD81_84;
   }
   if (TempD2>=84 && TempD2<87)
   {
    TempD3 = TempD2+dTD84_87;
   }
   if (TempD2>=87 && TempD2<90)
   {
    TempD3 = TempD2+dTD87_90;
   }
   if (TempD2>=90 && TempD2<91)
   {
    TempD3 = TempD2+dTD90_91;
   }
   if (TempD2>=91 && TempD2<92)
   {
    TempD3 = TempD2+dTD91_92;
   }
   if (TempD2>=92 && TempD2<93)
   {
    TempD3 = TempD2+dTD92_93;
   }
   if (TempD2>=93 && TempD2<94)
   {
    TempD3 = TempD2+dTD93_94;
   }
   if (TempD2>=94 && TempD2<95)
   {
    TempD3 = TempD2+dTD94_95;
   }
   if (TempD2>=95 && TempD2<96)
   {
    TempD3 = TempD2+dTD95_96;
   }
   if (TempD2>=96 && TempD2<97)
   {
    TempD3 = TempD2+dTD96_97;
   }
   if (TempD2>=97 && TempD2<98)
   {
    TempD3 = TempD2+dTD97_98;
   }  
   if (TempD2>=98 && TempD2<99)
   {
    TempD3 = TempD2+dTD98_99;
   }
   if (TempD2>=99 && TempD2<100)
   {
    TempD3 = TempD2+dTD99_100;
   }
// Вычислитель остаточной крепости в кубе
  if (TempK2 > 78.1)
   {
   Pr=Pressure/133.3;                                 // Переводим давление из паскалей в мм рт ст
   dP=Pr-760;                                         // Расчитываем разницу давлений между нормой 760 мм и текущим
   dT=0.035*dP;                                       // Расчитываем поправку к температуре исходя из давления
   // Приближение до восьмой степени, для использованя раскомментируйте 2 строчки ниже и закоментируйте 2 строчки 4 степени приближения.
// T1 = (TempK2 - dT - 89)/6.49; 
// K1= 17.26 - 18.32*T1 + 7.81*sq(T1) - 1.77*pow(T1,3) + 4.81*pow(T1,4) - 2.95*pow(T1,5) - 1.43*pow(T1,6) + 0.8*pow(T1,7) + 0.05*pow(T1,8);
   // Приближение до 4 степени
   T1 = (TempK2-dT-89.03)/6.54; 
   K1 = 16.75-19.05*T1+12.64*sq(T1)-3.69*pow(T1,3)-0.38*pow(T1,4);
   }
   TempD4 = TempD3 - dT;                              // Вносим поправку температуры от давления
   // Вычисляем крепость пара в дистилляторе
   if (TempD4>=T[0] && TempD4<T[122])
    {
    byte i=0;
    do
    { i=i+1;
    } while (TempD4>T[i]);
    K2 = K[i]+(K[i+1]-K[i])*(TempD4-T[i])/(T[i+1]-T[i]);
    }   
   lcd.begin(16, 2);                                  // Инициализация дисплея
   // Проверка нажатия кнопки
   if(digitalRead(14)==HIGH)
    {
     if(B==0)
      {
       B=1;
      }
     else 
      { 
       B=0;
      } 
    }
    // Проверка диапозона температур для пищалки
    if (TempK2 < Tvoda)
     {F=0;
      P1=0;
      P2=0;
      B=1;
     }
    if (TempK2 >= Tvoda && TempK2 < Tvoda2)
     {
      F=1;
     }
    if (TempK2 >= Tvoda2 && TempK2 < Tstop && A==0) 
     {
      F=2;
       if (P1==0)
        {
         B=1;
         P1=1;
        }
      }
    if (TempK2 >= Tvoda2 && K2 > Kstop && A!= 0) 
     {
      F=2;
       if (P1==0)
        {
         B=1;
         P1=1;
        }
      }
    if (TempK2 >= Tstop && A==0)
     {
      F=3;
       if (P2==0)
        {
         B=1;
         P2=1;
        }
      }
    if (K2 <= Kstop && A!= 0 && TempK2 >= Tvoda)
     {
      F=3;
       if (P2==0)
        {
         B=1;
         P2=1;
        }
      }
  // Проверка заполнения емкости
  if(E==1)
    {
     if(digitalRead(6)==LOW)
     {
      F=4;
     }
    } 
  // Проверка разлития жидкости на полу
  if(W==1)
    {
     if(digitalRead(3)==LOW)
     {
      F=5;
     }
    } 
 // Вывод на дисплей инфомации в зависимости от температуры
 switch(F)
  {
   case 1:
    // Текущая температура больше Tvoda но меньше Tvoda2 звук включен 
    if (B==1)                   
     {
      lcd.print("K "); 
      lcd.print(TempK2,1);                       // Температура в кубе
      lcd.print("\1 KP ");
      lcd.print(K1,0);                           // Крепость кубового остатка
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\3");                         // Звук включен
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);                       // Температура в дистилляторе
      lcd.print("\1 KP ");
      lcd.print(K2,0);                           // Крепость пара в дистилляторе
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F);                              // Режим диапозона температур
      tone(7, 700, 700);
     }
    // Текущая температура больше Tvoda но меньше Tvoda2 звук выключен 
    else                         
     {
      lcd.print("K "); 
      lcd.print(TempK2,1); 
      lcd.print("\1 KP ");
      lcd.print(K1,0);
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\4");
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F);
     }
   break;
   
   case 3: 
    // Текущая температура больше Tstop или крепость ниже Kstop звук включен
    if (B==1)                    
     {
      lcd.print("K "); 
      lcd.print(TempK2,1); 
      lcd.print("\1 KP ");
      lcd.print(K1,0);
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\3");
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F);
      tone(7, 700, 350);
     }
    // Текущая температура больше Tstop или крепость ниже Kstop звук выключен 
    else                         
     {
      lcd.print("K "); 
      lcd.print(TempK2,1); 
      lcd.print("\1 KP ");
      lcd.print(K1,0);
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\4");
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F);
     }
   break;
   
   case 2:
    // Текущая температура больше Tvoda2 но меньше Tstop звук включен
    if (B==1)                 
     {
      lcd.print("K "); 
      lcd.print(TempK2,1); 
      lcd.print("\1 KP ");
      lcd.print(K1,0);
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\3");
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F);
      delay(3000);
     }
    // Текущая температура больше Tvoda2 но меньше Tstop звук выключен 
    else                     
     {
      lcd.print("K "); 
      lcd.print(TempK2,1); 
      lcd.print("\1 KP ");
      lcd.print(K1,0);
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\4");
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F);
      delay(3000);
     }
   break;
   
   case 0:
    // Текущая температура меньше Tvoda звук включен
    if (B==1)                 
     {
      lcd.print("K "); 
      lcd.print(TempK2,1); 
      lcd.print("\1 KP ");
      lcd.print(K1,0);
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\3");
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F); 
      delay(3000);
     }
    // Текущая температура меньше Tvoda звук выключен 
    else                      
     {
      lcd.print("K "); 
      lcd.print(TempK2,1); 
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(14, 0);
      lcd.print("\2\4");
      lcd.setCursor(0, 1); 
      lcd.print("D ");
      lcd.print(TempD4,1);
      lcd.print("\1 KP ");
      lcd.print(K2,0);
      lcd.print("%");
      lcd.setCursor(15, 1);
      lcd.print(F); 
      delay(3000);
     }  
   break;
   // Сработал датчик заполнения приемной емкости 
   case 4:                      
    lcd.print("cMeHuTe EMkoCTb");
    tone(7, 700, 350);
   break;   
   // Сработал авариный датчик разлития жидкости на полу
   case 5:                      
    lcd.print("ABAPu\7 BODA");
    tone(7, 700, 350);
   break;     
  }
 }
